"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StructuralVariant(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "reportEvents",
        "variantCalls",
        "variantType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "coordinates": reports_6_6_0.Coordinates,
            "location": reports_6_6_0.Location,
            "reportEvents": reports_6_6_0.ReportEvent,
            "variantAttributes": reports_6_6_0.VariantAttributes,
            "variantCalls": reports_6_6_0.VariantCall,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "variantType": reports_6_6_0.StructuralVariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "org.gel.models.report.avro.Coordinates": reports_6_6_0.Coordinates,
            "org.gel.models.report.avro.Location": reports_6_6_0.Location,
            "org.gel.models.report.avro.ReportEvent": reports_6_6_0.ReportEvent,
            "org.gel.models.report.avro.VariantAttributes": reports_6_6_0.VariantAttributes,
            "org.gel.models.report.avro.VariantCall": reports_6_6_0.VariantCall,
            "org.gel.models.report.avro.StructuralVariantType": reports_6_6_0.StructuralVariantType,
            "org.gel.models.report.avro.StructuralVariant": reports_6_6_0.StructuralVariant,
        }

    __slots__ = [
        "reportEvents",
        "variantCalls",
        "variantType",
        "coordinates",
        "leftInsSeq",
        "location",
        "rightInsSeq",
        "variantAttributes",
    ]

    def __init__(
        self,
        reportEvents,
        variantCalls,
        variantType,
        coordinates=None,
        leftInsSeq=None,
        location=None,
        rightInsSeq=None,
        variantAttributes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_6_0.StructuralVariant model.

        :param reportEvents:
        :type reportEvents: list[ReportEvent]
        :param variantCalls:
            array of genotypes for the samples
        :type variantCalls: list[VariantCall]
        :param variantType:
            Structural Variant Type as would appear in VCF
        :type variantType: StructuralVariantType
        :param coordinates:
            DEPRECATED, use location.coordinates instead
        :type coordinates: None | Coordinates
        :param leftInsSeq:
        :type leftInsSeq: None | str
        :param location:
            Location of the variant in either genomic coordinates or an entity
            description if coordinates are not available.
        :type location: None | Location
        :param rightInsSeq:
        :type rightInsSeq: None | str
        :param variantAttributes:
        :type variantAttributes: None | VariantAttributes
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.6.0"
